PROGRAM WordCrosses;

#include "str.h"

CONST probname = 'NZ93_';
      prob_id = 'D';
      file_id = 'PROBLEM';
VAR   debugcounter: integer;

CONST blank = '          ';

TYPE  Word = string;

VAR   across1, across2, down1, down2: Word;
      a1, a2, d1, d2: integer;
      one, two, first: Boolean;

FUNCTION  ReadData: Boolean;     forward;
PROCEDURE SolveProblem;          forward;

PROCEDURE Error(s:string);
begin
  writeln; writeln(s); readln; HALT;
end;

PROCEDURE MainProg;
begin  {Main}

first := true;
while ReadData do
  SolveProblem;

end;

function ReadData: Boolean;
var s: string;
    i: integer;

PROCEDURE Extract(var w: word);
VAR p: integer;
begin
while s[1] = ' ' do Delete(s, 1, 1);
p := Pos(' ',s); w := Copy(s, 1, p); Delete(s, 1, p);
if w[length(w)] <> ' '
  then Error(w + ' is too long');
end;

begin {Read Data}
readln(s);
if s = '#'
  then ReadData := false
  else begin
    for i := 1 to length(s) do
      if not (s[i] in ['A'..'Z', ' '])
        then Error(s + ' contains illegal characters' + ' "' + s[i] + '"');
    s := s + ' ';
    Extract(across1); Extract(down1);
    Extract(across2); Extract(down2);
    ReadData := true end;
end;  {Read Data}

FUNCTION FindMatches(var across, down: Word; var a, d: integer): Boolean;
var found: Boolean;

begin
a := 0; found := false;
while (a < length(across)) and not found do begin
  Inc(a); d := 1;
  while (d < length(down)) and (across[a] <> down[d]) do Inc(d);
  found := (across[a] = down[d]) and (d < length(down));
  end;  {while a < length(across)}
FindMatches := found;
end;  {Find Matches}

PROCEDURE outstr(s : string);
VAR i, j : integer;
    done : boolean;
BEGIN
i := length(s);
done := false;
REPEAT
  if i = 0 then
    done := true
  else
    if s[i] <> ' ' then
      done := true
    else
      Dec(i);
UNTIL done;  
FOR j := 1 to i DO
  write(s[j]);
END;


PROCEDURE SolveProblem;
VAR i,j: integer;
    s : string;
begin
if first
  then first := false
  else begin
    writeln
    end;

if FindMatches(across1, down1, a1, d1) and
   FindMatches(across2, down2, a2, d2)
  then begin
    if d1 < d2
      then begin
        Insert(Copy(blank,1,d2-d1), down1, 1);
        while length(down1) > length(down2) do down2 := down2 + ' ';
        while length(down2) > length(down1) do down1 := down1 + ' ';
        i := length(down1);
        while (down1[i] = ' ') and (down2[i] = ' ') do begin
          Delete(down1, i, 1); Delete(down2, i, 1); Dec(i) end;
        for i := 1 to d2-1 do begin
	  s := '';
          for j := 1 to a1-1 do s := s + ' '; s := s + down1[i];
          for j := a1+1 to length(across1)+a2+1 do s := s + ' ';
          s := s + down2[i];
	  outstr(s);
	  writeln
          end;
        write(across1, '  ');
        outstr(across2);
        writeln;
        for i := d2+1 to length(down1) do begin
          s := '';
          for j := 1 to a1-1 do s := s + ' '; s := s + down1[i];
          for j := a1+1 to length(across1)+a2+1  do s := s + ' ';
          s := s + down2[i];
	  outstr(s);
	  writeln
          end;
        end
      else begin
        Insert(Copy(blank,1,d1-d2), down2, 1);
        while length(down1) > length(down2) do down2 := down2 + ' ';
        while length(down2) > length(down1) do down1 := down1 + ' ';
        i := length(down1);
        while (down1[i] = ' ') and (down2[i] = ' ') do begin
          Delete(down1, i, 1); Delete(down2, i, 1); Dec(i) end;
        for i := 1 to d1-1 do begin
          s := '';
          for j := 1 to a1-1 do s := s + ' '; s := s + down1[i];
          for j := a1+1 to length(across1)+a2+1  do s := s + ' ';
          s := s + down2[i];
	  outstr(s);
	  writeln
          end;
        write(across1, '  ');
	outstr(across2);
	writeln;
        for i := d1+1 to length(down1) do begin
	  s := '';
          for j := 1 to a1-1 do s := s + ' '; s := s + down1[i];
          for j := a1+1 to length(across1)+a2+1  do s := s + ' ';
	  s := s + down2[i];
	  outstr(s);
          writeln
          end;
        end;
    end  {of cross found}
  else begin writeln('Unable to make two crosses') end;
end;  {Solve Problem}

begin mainprog end.